package com.wissamfawaz;

import java.util.stream.IntStream;

public class Main {

	public static void main(String[] args) {
		int[] arr = {2, 3, 7, 6, 19, 10, 12};
		
		IntStream.of(arr)
			     .forEach(val -> System.out.printf("%d ", val));
		System.out.println();
		
		// Statistics
		System.out.printf("Count: %d%n", IntStream.of(arr).count());
		System.out.printf("Sum: %d%n", IntStream.of(arr).sum());
		System.out.printf("Min: %d%n", IntStream.of(arr).min().getAsInt());
		System.out.printf("Max: %d%n", IntStream.of(arr).max().getAsInt());
		System.out.printf("Avg: %.2f%n", IntStream.of(arr).average().getAsDouble());
		System.out.printf("Summary statistics: %s%n", IntStream.of(arr).summaryStatistics());
		
		// Reduction
		System.out.printf("Sum via reduce: %d%n", 
				IntStream.of(arr).reduce(0, (x, y) -> x + y));
		System.out.printf("Sum of squares via reduce: %d%n", 
				IntStream.of(arr).reduce(0, (x, y) -> x + y*y));
		System.out.printf("Product via reduce: %d%n", 
				IntStream.of(arr).reduce(1, (x, y) -> x*y));
		
		// Filtering and mapping
		System.out.printf("Even values sorted: %n");
		IntStream.of(arr)
				 .filter(val -> val % 2 == 0)
				 .sorted()
				 .forEach(val -> System.out.printf("%d ", val));
		System.out.println();
		System.out.printf("Odd values scaled by 10 sorted: %n");
		IntStream.of(arr)
				 .filter(val -> val % 2 != 0)
				 .map(val -> val * 10)
				 .sorted()
				 .forEach(val -> System.out.printf("%d ", val));
		
		
		
		
		
		
		
		
		
		
		

	}

}
